#include "include_llvm.hxx"

#include <iostream>
#include <climits>

#include <QApplication>
#include <QCommandLineParser>
#include <QTextEdit>

#include "log4cxx/logger.h"
#include "log4cxx/basicconfigurator.h"

#include "gui/Mainwindow.hxx"

using std::cout;
using std::cin;
using std::cerr;

int main(int argc, char** argv)
{
    log4cxx::BasicConfigurator::configure();
    log4cxx::LoggerPtr _logger(log4cxx::Logger::getLogger("main"));

    LOG4CXX_DEBUG(_logger, "Initializing LLVM");
    llvm::InitializeAllTargetInfos();
    llvm::InitializeAllTargetMCs();
    llvm::InitializeAllAsmParsers();
    llvm::InitializeAllDisassemblers();

    LOG4CXX_DEBUG(_logger, "Initializing Qt");
    QApplication app(argc, argv);
	QCommandLineParser parser;

	QApplication::setApplicationName("frida");
	parser.addHelpOption();
	parser.process(app);

    Mainwindow m;
    m.show();

    return app.exec();
}
